Index: c/src/exec/score/src/threadchangepriority.c
===================================================================
--- c/src/exec/score/src/threadchangepriority.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadchangepriority.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,109 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Change_priority
+ *
+ *  This kernel routine changes the priority of the thread.  The
+ *  thread chain is adjusted if necessary.
+ *
+ *  Input parameters:
+ *    the_thread   - pointer to thread control block
+ *    new_priority - ultimate priority
+ *    prepend_it   - TRUE if the thread should be prepended to the chain
+ *
+ *  Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    ready chain
+ *    select heir
+ */
+
+void _Thread_Change_priority(
+  Thread_Control   *the_thread,
+  Priority_Control  new_priority,
+  boolean           prepend_it
+)
+{
+  ISR_Level level;
+  /* boolean   do_prepend = FALSE; */
+
+  /*
+   *  If this is a case where prepending the task to its priority is
+   *  potentially desired, then we need to consider whether to do it.
+   *  This usually occurs when a task lowers its priority implcitly as
+   *  the result of losing inherited priority.  Normal explicit priority
+   *  change calls (e.g. rtems_task_set_priority) should always do an
+   *  append not a prepend.
+   */
+ 
+  /*
+   *  Techically, the prepend should conditional on the thread lowering
+   *  its priority but that does allow cxd2004 of the acvc 2.0.1 to 
+   *  pass with rtems 4.0.0.  This should change when gnat redoes its
+   *  priority scheme.
+   */
+/*
+  if ( prepend_it &&
+       _Thread_Is_executing( the_thread ) && 
+       new_priority >= the_thread->current_priority )
+    prepend_it = TRUE;
+*/
+                  
+  _Thread_Set_transient( the_thread );
+
+  if ( the_thread->current_priority != new_priority )
+    _Thread_Set_priority( the_thread, new_priority );
+
+  _ISR_Disable( level );
+
+  the_thread->current_state =
+    _States_Clear( STATES_TRANSIENT, the_thread->current_state );
+
+  if ( ! _States_Is_ready( the_thread->current_state ) ) {
+    _ISR_Enable( level );
+    return;
+  }
+
+  _Priority_Add_to_bit_map( &the_thread->Priority_map );
+  if ( prepend_it )
+    _Chain_Prepend_unprotected( the_thread->ready, &the_thread->Object.Node );
+  else
+    _Chain_Append_unprotected( the_thread->ready, &the_thread->Object.Node );
+
+  _ISR_Flash( level );
+
+  _Thread_Calculate_heir();
+
+  if ( !_Thread_Is_executing_also_the_heir() &&
+       _Thread_Executing->is_preemptible )
+    _Context_Switch_necessary = TRUE;
+  _ISR_Enable( level );
+}
Index: c/src/exec/score/src/threadclearstate.c
===================================================================
--- c/src/exec/score/src/threadclearstate.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadclearstate.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,82 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Clear_state
+ *
+ *  This kernel routine clears the appropriate states in the
+ *  requested thread.  The thread ready chain is adjusted if
+ *  necessary and the Heir thread is set accordingly.
+ *
+ *  Input parameters:
+ *    the_thread - pointer to thread control block
+ *    state      - state set to clear
+ *
+ *  Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    priority map
+ *    select heir
+ */
+
+
+void _Thread_Clear_state(
+  Thread_Control *the_thread,
+  States_Control  state
+)
+{
+  ISR_Level       level;
+  States_Control  current_state;
+
+  _ISR_Disable( level );
+    current_state = the_thread->current_state;
+    
+    if ( current_state & state ) {
+      current_state = 
+      the_thread->current_state = _States_Clear( state, current_state );
+
+      if ( _States_Is_ready( current_state ) ) {
+
+        _Priority_Add_to_bit_map( &the_thread->Priority_map );
+
+        _Chain_Append_unprotected(the_thread->ready, &the_thread->Object.Node);
+
+        _ISR_Flash( level );
+
+        if ( the_thread->current_priority < _Thread_Heir->current_priority ) {
+          _Thread_Heir = the_thread;
+          if ( _Thread_Executing->is_preemptible ||
+               the_thread->current_priority == 0 )
+            _Context_Switch_necessary = TRUE;
+        }
+      }
+  }
+  _ISR_Enable( level );
+}
Index: c/src/exec/score/src/threadclose.c
===================================================================
--- c/src/exec/score/src/threadclose.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadclose.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,71 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*
+ *  _Thread_Close
+ *
+ *  DESCRIPTION:
+ *
+ *  XXX
+ */
+ 
+void _Thread_Close(
+  Objects_Information  *information,
+  Thread_Control       *the_thread
+)
+{
+  _Objects_Close( information, &the_thread->Object );
+ 
+  _Thread_Set_state( the_thread, STATES_TRANSIENT );
+ 
+  if ( !_Thread_queue_Extract_with_proxy( the_thread ) ) {
+ 
+    if ( _Watchdog_Is_active( &the_thread->Timer ) )
+      (void) _Watchdog_Remove( &the_thread->Timer );
+  }
+
+  _User_extensions_Thread_delete( the_thread );
+ 
+#if ( CPU_USE_DEFERRED_FP_SWITCH == TRUE )
+  if ( _Thread_Is_allocated_fp( the_thread ) )
+    _Thread_Deallocate_fp();
+#endif
+  the_thread->fp_context = NULL;
+
+  if ( the_thread->Start.fp_context )
+  (void) _Workspace_Free( the_thread->Start.fp_context );
+
+  _Thread_Stack_Free( the_thread );
+
+  if ( the_thread->extensions )
+    (void) _Workspace_Free( the_thread->extensions );
+
+  the_thread->Start.stack = NULL;
+  the_thread->extensions = NULL;
+}
Index: c/src/exec/score/src/threadcreateidle.c
===================================================================
--- c/src/exec/score/src/threadcreateidle.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadcreateidle.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,97 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Create_idle
+ */
+
+char *_Thread_Idle_name = "IDLE";
+
+void _Thread_Create_idle( void )
+{
+  void       *idle;
+  unsigned32  idle_task_stack_size;
+
+  /*
+   *  The entire workspace is zeroed during its initialization.  Thus, all
+   *  fields not explicitly assigned were explicitly zeroed by
+   *  _Workspace_Initialization.
+   */
+ 
+  _Thread_Idle = _Thread_Internal_allocate();
+ 
+  /*
+   *  Initialize the IDLE task.
+   */
+ 
+#if (CPU_PROVIDES_IDLE_THREAD_BODY == TRUE)
+  idle = (void *) _CPU_Thread_Idle_body;
+#else
+  idle = (void *) _Thread_Idle_body;
+#endif
+ 
+  if ( _CPU_Table.idle_task )
+    idle = _CPU_Table.idle_task;
+ 
+  idle_task_stack_size =  _CPU_Table.idle_task_stack_size;
+  if ( idle_task_stack_size < STACK_MINIMUM_SIZE )
+    idle_task_stack_size = STACK_MINIMUM_SIZE;
+ 
+  _Thread_Initialize(
+    &_Thread_Internal_information,
+    _Thread_Idle,
+    NULL,        /* allocate the stack */
+    idle_task_stack_size,
+    CPU_IDLE_TASK_IS_FP,
+    PRIORITY_MAXIMUM,
+    TRUE,        /* preemptable */
+    THREAD_CPU_BUDGET_ALGORITHM_NONE,
+    NULL,        /* no budget algorithm callout */
+    0,           /* all interrupts enabled */
+    _Thread_Idle_name
+  );
+ 
+  /*
+   *  WARNING!!! This is necessary to "kick" start the system and
+   *             MUST be done before _Thread_Start is invoked.
+   */
+ 
+  _Thread_Heir      =
+  _Thread_Executing = _Thread_Idle;
+ 
+  _Thread_Start(
+    _Thread_Idle,
+    THREAD_START_NUMERIC,
+    idle,
+    NULL,
+    0
+  );
+ 
+}
Index: c/src/exec/score/src/threaddelayended.c
===================================================================
--- c/src/exec/score/src/threaddelayended.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threaddelayended.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,61 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Delay_ended
+ *
+ *  This routine processes a thread whose delay period has ended.
+ *  It is called by the watchdog handler.
+ *
+ *  Input parameters:
+ *    id - thread id
+ *
+ *  Output parameters: NONE
+ */
+
+void _Thread_Delay_ended(
+  Objects_Id  id,
+  void       *ignored
+)
+{
+  Thread_Control    *the_thread;
+  Objects_Locations  location;
+
+  the_thread = _Thread_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+    case OBJECTS_REMOTE:  /* impossible */
+      break;
+    case OBJECTS_LOCAL:
+      _Thread_Unblock( the_thread );
+      _Thread_Unnest_dispatch();
+      break;
+  }
+}
Index: c/src/exec/score/src/threaddispatch.c
===================================================================
--- c/src/exec/score/src/threaddispatch.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threaddispatch.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,130 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Dispatch
+ *
+ *  This kernel routine determines if a dispatch is needed, and if so
+ *  dispatches to the heir thread.  Once the heir is running an attempt
+ *  is made to dispatch any ASRs.
+ *
+ *  ALTERNATE ENTRY POINTS:
+ *    void _Thread_Enable_dispatch();
+ *
+ *  Input parameters:  NONE
+ *
+ *  Output parameters:  NONE
+ *
+ *  INTERRUPT LATENCY:
+ *    dispatch thread
+ *    no dispatch thread
+ */
+
+#if ( CPU_INLINE_ENABLE_DISPATCH == FALSE )
+void _Thread_Enable_dispatch( void )
+{
+  if ( --_Thread_Dispatch_disable_level )
+    return;
+  _Thread_Dispatch();
+}
+#endif
+
+void _Thread_Dispatch( void )
+{
+  Thread_Control   *executing;
+  Thread_Control   *heir;
+  ISR_Level         level;
+
+  executing   = _Thread_Executing;
+  _ISR_Disable( level );
+  while ( _Context_Switch_necessary == TRUE ) {
+    heir = _Thread_Heir;
+    _Thread_Dispatch_disable_level = 1;
+    _Context_Switch_necessary = FALSE;
+    _Thread_Executing = heir;
+    executing->rtems_ada_self = rtems_ada_self;
+    rtems_ada_self = heir->rtems_ada_self;
+    _ISR_Enable( level );
+
+    heir->ticks_executed++;
+
+    _User_extensions_Thread_switch( executing, heir );
+
+    if ( heir->budget_algorithm == THREAD_CPU_BUDGET_ALGORITHM_RESET_TIMESLICE )
+      heir->cpu_time_budget = _Thread_Ticks_per_timeslice;
+
+    /*
+     *  If the CPU has hardware floating point, then we must address saving
+     *  and restoring it as part of the context switch.
+     *
+     *  The second conditional compilation section selects the algorithm used
+     *  to context switch between floating point tasks.  The deferred algorithm
+     *  can be significantly better in a system with few floating point tasks
+     *  because it reduces the total number of save and restore FP context
+     *  operations.  However, this algorithm can not be used on all CPUs due
+     *  to unpredictable use of FP registers by some compilers for integer
+     *  operations.
+     */
+
+#if ( CPU_HARDWARE_FP == TRUE )
+#if ( CPU_USE_DEFERRED_FP_SWITCH == TRUE )
+    if ( (heir->fp_context != NULL) && !_Thread_Is_allocated_fp( heir ) ) {
+      if ( _Thread_Allocated_fp != NULL )
+        _Context_Save_fp( &_Thread_Allocated_fp->fp_context );
+      _Context_Restore_fp( &heir->fp_context );
+      _Thread_Allocated_fp = heir;
+    }
+#else
+    if ( executing->fp_context != NULL )
+      _Context_Save_fp( &executing->fp_context );
+
+    if ( heir->fp_context != NULL )
+      _Context_Restore_fp( &heir->fp_context );
+#endif
+#endif
+
+    _Context_Switch( &executing->Registers, &heir->Registers );
+
+    executing = _Thread_Executing;
+
+    _ISR_Disable( level );
+  }
+
+  _Thread_Dispatch_disable_level = 0;
+
+  _ISR_Enable( level );
+
+  if ( _Thread_Do_post_task_switch_extension ||
+       executing->do_post_task_switch_extension ) {
+    executing->do_post_task_switch_extension = FALSE;
+    _API_extensions_Run_postswitch();
+  }
+ 
+}
Index: c/src/exec/score/src/threadevaluatemode.c
===================================================================
--- c/src/exec/score/src/threadevaluatemode.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadevaluatemode.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,50 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Evaluate_mode
+ *
+ *  XXX
+ */
+
+boolean _Thread_Evaluate_mode( void )
+{
+  Thread_Control     *executing;
+
+  executing = _Thread_Executing;
+
+  if ( !_States_Is_ready( executing->current_state ) ||
+       ( !_Thread_Is_heir( executing ) && executing->is_preemptible ) ) {
+    _Context_Switch_necessary = TRUE;
+    return TRUE;
+  }
+
+  return FALSE;
+}
Index: c/src/exec/score/src/threadget.c
===================================================================
--- c/src/exec/score/src/threadget.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadget.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,73 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Get
+ *
+ *  NOTE:  If we are not using static inlines, this must be a real
+ *         subroutine call.
+ *
+ *  NOTE:  XXX... This routine may be able to be optimized.
+ */
+
+#ifndef USE_INLINES
+
+Thread_Control *_Thread_Get (
+  Objects_Id           id,
+  Objects_Locations   *location
+)
+{
+  Objects_Classes      the_class;
+  Objects_Information *information;
+ 
+  if ( _Objects_Are_ids_equal( id, OBJECTS_ID_OF_SELF ) ) {
+    _Thread_Disable_dispatch();
+    *location = OBJECTS_LOCAL;
+    return( _Thread_Executing );
+  }
+ 
+  the_class = _Objects_Get_class( id );
+ 
+  if ( the_class > OBJECTS_CLASSES_LAST ) {
+    *location = OBJECTS_ERROR;
+    return (Thread_Control *) 0;
+  } 
+ 
+  information = _Objects_Information_table[ the_class ];
+ 
+  if ( !information || !information->is_thread ) { 
+    *location = OBJECTS_ERROR;
+    return (Thread_Control *) 0;
+  }
+ 
+  return (Thread_Control *) _Objects_Get( information, id, location );
+}
+
+#endif
Index: c/src/exec/score/src/threadhandler.c
===================================================================
--- c/src/exec/score/src/threadhandler.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadhandler.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,119 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Handler
+ *
+ *  This routine is the "primal" entry point for all threads.
+ *  _Context_Initialize() dummies up the thread's initial context
+ *  to cause the first Context_Switch() to jump to _Thread_Handler().
+ *
+ *  This routine is the default thread exitted error handler.  It is
+ *  returned to when a thread exits.  The configured fatal error handler
+ *  is invoked to process the exit.
+ *
+ *  NOTE:
+ *
+ *  On entry, it is assumed all interrupts are blocked and that this
+ *  routine needs to set the initial isr level.  This may or may not 
+ *  actually be needed by the context switch routine and as a result
+ *  interrupts may already be at there proper level.  Either way,
+ *  setting the initial isr level properly here is safe.
+ *  
+ *  Currently this is only really needed for the posix port,
+ *  ref: _Context_Switch in unix/cpu.c
+ *
+ *  Input parameters:   NONE
+ *
+ *  Output parameters:  NONE
+ */
+
+void _Thread_Handler( void )
+{
+  ISR_Level  level;
+  Thread_Control *executing;
+ 
+  executing = _Thread_Executing;
+ 
+  /*
+   * have to put level into a register for those cpu's that use
+   * inline asm here
+   */
+ 
+  level = executing->Start.isr_level;
+  _ISR_Set_level(level);
+
+  /*
+   * Take care that 'begin' extensions get to complete before
+   * 'switch' extensions can run.  This means must keep dispatch
+   * disabled until all 'begin' extensions complete.
+   */
+ 
+  _User_extensions_Thread_begin( executing );
+ 
+  /*
+   *  At this point, the dispatch disable level BETTER be 1.
+   */
+
+  _Thread_Enable_dispatch();
+ 
+  switch ( executing->Start.prototype ) {
+    case THREAD_START_NUMERIC:
+      (*(Thread_Entry_numeric) executing->Start.entry_point)(
+        executing->Start.numeric_argument
+      );
+      break;
+    case THREAD_START_POINTER:
+      (*(Thread_Entry_pointer) executing->Start.entry_point)(
+        executing->Start.pointer_argument
+      );
+      break;
+    case THREAD_START_BOTH_POINTER_FIRST:
+      (*(Thread_Entry_both_pointer_first) executing->Start.entry_point)( 
+        executing->Start.pointer_argument,
+        executing->Start.numeric_argument
+      );
+      break;
+    case THREAD_START_BOTH_NUMERIC_FIRST:
+      (*(Thread_Entry_both_numeric_first) executing->Start.entry_point)( 
+        executing->Start.numeric_argument,
+        executing->Start.pointer_argument
+      );
+      break;
+  }
+
+  _User_extensions_Thread_exitted( executing );
+
+  _Internal_error_Occurred(
+    INTERNAL_ERROR_CORE,
+    TRUE,
+    INTERNAL_ERROR_THREAD_EXITTED
+  );
+}
Index: c/src/exec/score/src/threadidlebody.c
===================================================================
--- c/src/exec/score/src/threadidlebody.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadidlebody.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,51 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Idle_body
+ *
+ *  This kernel routine is the idle thread.  The idle thread runs any time
+ *  no other thread is ready to run.  This thread loops forever with
+ *  interrupts enabled.
+ *
+ *  Input parameters:
+ *    ignored - this parameter is ignored
+ *
+ *  Output parameters:  NONE
+ */
+ 
+#if (CPU_PROVIDES_IDLE_THREAD_BODY == FALSE)
+Thread _Thread_Idle_body(
+  unsigned32 ignored
+)
+{
+  for( ; ; ) ;
+}
+#endif
Index: c/src/exec/score/src/threadinitialize.c
===================================================================
--- c/src/exec/score/src/threadinitialize.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
+++ c/src/exec/score/src/threadinitialize.c	(revision 05df0a846f436295a490cc9ac19e5a4061c3a575)
@@ -0,0 +1,175 @@
+/*
+ *  Thread Handler
+ *
+ *
+ *  COPYRIGHT (c) 1989-1998.
+ *  On-Line Applications Research Corporation (OAR).
+ *  Copyright assigned to U.S. Government, 1994.
+ *
+ *  The license and distribution terms for this file may be
+ *  found in found in the file LICENSE in this distribution or at
+ *  http://www.OARcorp.com/rtems/license.html.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/score/apiext.h>
+#include <rtems/score/context.h>
+#include <rtems/score/interr.h>
+#include <rtems/score/isr.h>
+#include <rtems/score/object.h>
+#include <rtems/score/priority.h>
+#include <rtems/score/states.h>
+#include <rtems/score/sysstate.h>
+#include <rtems/score/thread.h>
+#include <rtems/score/threadq.h>
+#include <rtems/score/userext.h>
+#include <rtems/score/wkspace.h>
+
+/*PAGE
+ *
+ *  _Thread_Initialize
+ *
+ *  XXX
+ */
+
+boolean _Thread_Initialize(
+  Objects_Information                  *information,
+  Thread_Control                       *the_thread,
+  void                                 *stack_area,
+  unsigned32                            stack_size,
+  boolean                               is_fp,
+  Priority_Control                      priority,
+  boolean                               is_preemptible,
+  Thread_CPU_budget_algorithms          budget_algorithm,
+  Thread_CPU_budget_algorithm_callout   budget_callout,
+  unsigned32                            isr_level,
+  Objects_Name                          name
+)
+{
+  unsigned32           actual_stack_size = 0;
+  void                *stack = NULL;
+  void                *fp_area;
+  void                *extensions_area;
+
+  /*
+   *  Initialize the Ada self pointer
+   */
+
+  the_thread->rtems_ada_self = NULL;
+
+  /*
+   *  Allocate and Initialize the stack for this thread.
+   */
+
+
+  if ( !stack_area ) {
+    if ( !_Stack_Is_enough( stack_size ) )
+      actual_stack_size = STACK_MINIMUM_SIZE;
+    else
+      actual_stack_size = stack_size;
+
+    actual_stack_size = _Thread_Stack_Allocate( the_thread, actual_stack_size );
+ 
+    if ( !actual_stack_size ) 
+      return FALSE;                     /* stack allocation failed */
+
+    stack = the_thread->Start.stack;
+    the_thread->Start.core_allocated_stack = TRUE;
+  } else {
+    stack = stack_area;
+    actual_stack_size = stack_size;
+    the_thread->Start.core_allocated_stack = FALSE;
+  }
+
+  _Stack_Initialize(
+     &the_thread->Start.Initial_stack,
+     stack,
+     actual_stack_size
+  );
+
+  /*
+   *  Allocate the floating point area for this thread
+   */
+  
+  if ( is_fp ) {
+
+    fp_area = _Workspace_Allocate( CONTEXT_FP_SIZE );
+    if ( !fp_area ) {
+      _Thread_Stack_Free( the_thread );
+      return FALSE;
+    }
+    fp_area = _Context_Fp_start( fp_area, 0 );
+
+  } else
+    fp_area = NULL;
+
+  the_thread->fp_context       = fp_area;
+  the_thread->Start.fp_context = fp_area;
+
+  /*
+   *  Allocate the extensions area for this thread
+   */
+
+  if ( _Thread_Maximum_extensions ) {
+    extensions_area = _Workspace_Allocate(
+      (_Thread_Maximum_extensions + 1) * sizeof( void * )
+    );
+
+    if ( !extensions_area ) {
+      if ( fp_area )
+        (void) _Workspace_Free( fp_area );
+
+      _Thread_Stack_Free( the_thread );
+
+      return FALSE;
+    }
+  } else 
+    extensions_area = NULL;
+  
+  the_thread->extensions = (void **) extensions_area;
+
+  /*
+   *  General initialization
+   */
+
+  the_thread->Start.is_preemptible   = is_preemptible;
+  the_thread->Start.budget_algorithm = budget_algorithm;
+  the_thread->Start.budget_callout   = budget_callout;
+  the_thread->Start.isr_level        = isr_level;
+
+  the_thread->current_state          = STATES_DORMANT;
+  the_thread->resource_count         = 0;
+  the_thread->real_priority          = priority;
+  the_thread->Start.initial_priority = priority;
+  the_thread->ticks_executed         = 0;
+ 
+  _Thread_Set_priority( the_thread, priority );
+
+  /*
+   *  Open the object
+   */
+
+  _Objects_Open( information, &the_thread->Object, name );
+
+  /*
+   *  Invoke create extensions
+   */
+
+  if ( !_User_extensions_Thread_create( the_thread ) ) {
+
+    if ( extensions_area )
+      (void) _Workspace_Free( extensions_area );
+
+    if ( fp_area )
+      (void) _Workspace_Free( fp_area );
+
+    _Thread_Stack_Free( the_thread );
+
+    return FALSE;
+  }
+
+  return TRUE;
+   
+}
